import {ClientLogger}from'@cdm-logger/client';import {getEnvironment}from'@common-stack/core';export{default}from'../modules.js';class UtilityClass {
    modules;
    cache = { key: null, modules: null };
    constructor(modules) {
        this.modules = modules;
        // Setup HMR to invalidate cache when modules change
        // @ts-ignore
        if (import.meta.hot) {
            // @ts-ignore
            import.meta.hot.accept('./modules', (newModules) => {
                this.modules = newModules.default;
                this.cache.key = null; // Invalidate cache
                this.cache.modules = null;
            });
        }
    }
    getCacheKey(storeObj) {
        // Check if the modules reference has changed or cache is invalidated
        if (this.cache.modules !== this.modules) {
            // Modules have changed, recalculate the cache key
            this.cache.modules = this.modules;
            this.cache.key = this.modules.getDataIdFromObject(storeObj);
        }
        return this.cache.key;
    }
}
const appEnv = getEnvironment();
const logger = ClientLogger.create(appEnv.APP_NAME || 'Fullstack-Pro', {
    level: appEnv.LOG_LEVEL || 'info',
});export{UtilityClass,logger};